<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `crates&#x2F;framework&#x2F;base&#x2F;icecap-fdt&#x2F;bindings&#x2F;src&#x2F;icecap.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>icecap.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../icecap_fdt_bindings/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">alloc::prelude::v1</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">core::ops::Range</span>;

<span class="kw">use</span> <span class="ident">serde</span>::{<span class="ident">Deserialize</span>, <span class="ident">Serialize</span>};

<span class="kw">use</span> <span class="ident">icecap_fdt::bindings</span>::{<span class="ident">Cells</span>, <span class="ident">SizeSpec</span>};
<span class="kw">use</span> <span class="ident">icecap_fdt</span>::{<span class="ident">DeviceTree</span>, <span class="ident">Node</span>};

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Serialize</span>, <span class="ident">Deserialize</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">RingBuffer</span> {
    <span class="kw">pub</span> <span class="ident">read</span>: <span class="ident">RingBufferSide</span>,
    <span class="kw">pub</span> <span class="ident">write</span>: <span class="ident">RingBufferSide</span>,
    <span class="kw">pub</span> <span class="ident">kick</span>: <span class="ident">Kick</span>,
}

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Serialize</span>, <span class="ident">Deserialize</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">RingBufferSide</span> {
    <span class="kw">pub</span> <span class="ident">ctrl</span>: <span class="ident">Range</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>,
    <span class="kw">pub</span> <span class="ident">data</span>: <span class="ident">Range</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>,
}

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Serialize</span>, <span class="ident">Deserialize</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">Kick</span> {
    <span class="ident">Raw</span> { <span class="ident">notification</span>: <span class="ident">u64</span> },
    <span class="ident">Managed</span> { <span class="ident">endpoints</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u64</span><span class="op">&gt;</span>, <span class="ident">message</span>: <span class="ident">u64</span> },
}

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Serialize</span>, <span class="ident">Deserialize</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Channel</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
    <span class="kw">pub</span> <span class="ident">ring_buffer</span>: <span class="ident">T</span>,
    <span class="kw">pub</span> <span class="ident">irq</span>: <span class="ident">u32</span>,
    <span class="kw">pub</span> <span class="ident">name</span>: <span class="ident">String</span>,
    <span class="kw">pub</span> <span class="ident">id</span>: <span class="ident">u32</span>,
}

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Serialize</span>, <span class="ident">Deserialize</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Con</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
    <span class="kw">pub</span> <span class="ident">ring_buffer</span>: <span class="ident">T</span>,
    <span class="kw">pub</span> <span class="ident">irq</span>: <span class="ident">u32</span>,
}

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Serialize</span>, <span class="ident">Deserialize</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Net</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
    <span class="kw">pub</span> <span class="ident">ring_buffer</span>: <span class="ident">T</span>,
    <span class="kw">pub</span> <span class="ident">mtu</span>: <span class="ident">u32</span>,
    <span class="kw">pub</span> <span class="ident">mac_address</span>: [<span class="ident">u8</span>; <span class="number">6</span>],
    <span class="kw">pub</span> <span class="ident">irq</span>: <span class="ident">u32</span>,
}

<span class="kw">impl</span> <span class="ident">RingBuffer</span> {
    <span class="kw">fn</span> <span class="ident">set_reg</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">node</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">Node</span>, <span class="ident">spec</span>: <span class="ident">SizeSpec</span>) {
        <span class="kw">use</span> <span class="ident">Cells</span>::<span class="kw-2">*</span>;
        <span class="ident">node</span>.<span class="ident">set_property_cells</span>(
            <span class="string">&quot;reg&quot;</span>,
            <span class="ident">spec</span>,
            <span class="macro">vec!</span>[
                <span class="ident">Address</span>(<span class="self">self</span>.<span class="ident">read</span>.<span class="ident">ctrl</span>.<span class="ident">start</span>),
                <span class="ident">Size</span>(<span class="self">self</span>.<span class="ident">read</span>.<span class="ident">ctrl</span>.<span class="ident">len</span>()),
                <span class="ident">Address</span>(<span class="self">self</span>.<span class="ident">write</span>.<span class="ident">ctrl</span>.<span class="ident">start</span>),
                <span class="ident">Size</span>(<span class="self">self</span>.<span class="ident">write</span>.<span class="ident">ctrl</span>.<span class="ident">len</span>()),
                <span class="ident">Address</span>(<span class="self">self</span>.<span class="ident">read</span>.<span class="ident">data</span>.<span class="ident">start</span>),
                <span class="ident">Size</span>(<span class="self">self</span>.<span class="ident">read</span>.<span class="ident">data</span>.<span class="ident">len</span>()),
                <span class="ident">Address</span>(<span class="self">self</span>.<span class="ident">write</span>.<span class="ident">data</span>.<span class="ident">start</span>),
                <span class="ident">Size</span>(<span class="self">self</span>.<span class="ident">write</span>.<span class="ident">data</span>.<span class="ident">len</span>()),
            ],
        );
        <span class="kw">match</span> <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">kick</span> {
            <span class="ident">Kick::Raw</span> { <span class="ident">notification</span> } <span class="op">=</span><span class="op">&gt;</span> {
                <span class="ident">node</span>.<span class="ident">set_property</span>(<span class="string">&quot;kick-type&quot;</span>, <span class="string">&quot;unmanaged&quot;</span>);
                <span class="ident">node</span>.<span class="ident">set_property</span>(<span class="string">&quot;kick-notification&quot;</span>, <span class="ident">notification</span>);
            }
            <span class="ident">Kick::Managed</span> { <span class="ident">endpoints</span>, <span class="ident">message</span> } <span class="op">=</span><span class="op">&gt;</span> {
                <span class="ident">node</span>.<span class="ident">set_property</span>(<span class="string">&quot;kick-type&quot;</span>, <span class="string">&quot;managed&quot;</span>);
                <span class="ident">node</span>.<span class="ident">set_property</span>(<span class="string">&quot;kick-message&quot;</span>, <span class="ident">message</span>);
                <span class="ident">node</span>.<span class="ident">set_property_cells</span>(
                    <span class="string">&quot;kick-endpoints&quot;</span>,
                    <span class="ident">spec</span>,
                    <span class="ident">endpoints</span>.<span class="ident">iter</span>().<span class="ident">map</span>(<span class="op">|</span><span class="ident">endpoint</span><span class="op">|</span> <span class="ident">Raw64</span>(<span class="kw-2">*</span><span class="ident">endpoint</span>)),
                );
            }
        }
    }
}

<span class="kw">impl</span> <span class="ident">Net</span><span class="op">&lt;</span><span class="ident">RingBuffer</span><span class="op">&gt;</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">apply</span><span class="op">&lt;</span><span class="ident">K</span>: <span class="ident">Into</span><span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">name</span>: <span class="ident">K</span>, <span class="ident">dt</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">DeviceTree</span>) {
        <span class="kw">let</span> <span class="ident">spec</span> <span class="op">=</span> <span class="ident">dt</span>.<span class="ident">root</span>.<span class="ident">get_size_spec</span>();
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">node</span> <span class="op">=</span> <span class="ident">Node::new</span>();
        <span class="ident">node</span>.<span class="ident">set_compatible</span>(<span class="string">&quot;icecap,net&quot;</span>);
        <span class="ident">node</span>.<span class="ident">set_property</span>(<span class="string">&quot;mtu&quot;</span>, <span class="self">self</span>.<span class="ident">mtu</span>);
        <span class="ident">node</span>.<span class="ident">set_property</span>(<span class="string">&quot;local-mac-address&quot;</span>, <span class="self">self</span>.<span class="ident">mac_address</span>.<span class="ident">to_vec</span>());
        <span class="ident">node</span>.<span class="ident">set_property_iter</span>(<span class="string">&quot;interrupts&quot;</span>, <span class="kw-2">&amp;</span>[<span class="number">0</span>, <span class="self">self</span>.<span class="ident">irq</span>, <span class="number">1</span>]);
        <span class="self">self</span>.<span class="ident">ring_buffer</span>.<span class="ident">set_reg</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">node</span>, <span class="ident">spec</span>);
        <span class="ident">dt</span>.<span class="ident">root</span>.<span class="ident">set_child</span>(<span class="ident">name</span>, <span class="ident">node</span>);
    }
}

<span class="kw">impl</span> <span class="ident">Con</span><span class="op">&lt;</span><span class="ident">RingBuffer</span><span class="op">&gt;</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">apply</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">name</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>, <span class="ident">dt</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">DeviceTree</span>) {
        <span class="kw">let</span> <span class="ident">spec</span> <span class="op">=</span> <span class="ident">dt</span>.<span class="ident">root</span>.<span class="ident">get_size_spec</span>();
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">node</span> <span class="op">=</span> <span class="ident">Node::new</span>();
        <span class="ident">node</span>.<span class="ident">set_compatible</span>(<span class="string">&quot;icecap,con&quot;</span>);
        <span class="ident">node</span>.<span class="ident">set_property_iter</span>(<span class="string">&quot;interrupts&quot;</span>, <span class="kw-2">&amp;</span>[<span class="number">0</span>, <span class="self">self</span>.<span class="ident">irq</span>, <span class="number">1</span>]);
        <span class="self">self</span>.<span class="ident">ring_buffer</span>.<span class="ident">set_reg</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">node</span>, <span class="ident">spec</span>);
        <span class="ident">dt</span>.<span class="ident">root</span>.<span class="ident">set_child</span>(<span class="ident">name</span>, <span class="ident">node</span>);
    }
}

<span class="kw">impl</span> <span class="ident">Channel</span><span class="op">&lt;</span><span class="ident">RingBuffer</span><span class="op">&gt;</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">apply</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">name</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>, <span class="ident">dt</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">DeviceTree</span>) {
        <span class="kw">let</span> <span class="ident">spec</span> <span class="op">=</span> <span class="ident">dt</span>.<span class="ident">root</span>.<span class="ident">get_size_spec</span>();
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">node</span> <span class="op">=</span> <span class="ident">Node::new</span>();
        <span class="ident">node</span>.<span class="ident">set_compatible</span>(<span class="string">&quot;icecap,channel&quot;</span>);
        <span class="ident">node</span>.<span class="ident">set_property</span>(<span class="string">&quot;channel-name&quot;</span>, <span class="self">self</span>.<span class="ident">name</span>.<span class="ident">as_str</span>()); <span class="comment">// property &quot;name&quot; is reserved</span>
        <span class="ident">node</span>.<span class="ident">set_property</span>(<span class="string">&quot;id&quot;</span>, <span class="self">self</span>.<span class="ident">id</span>);
        <span class="ident">node</span>.<span class="ident">set_property_iter</span>(<span class="string">&quot;interrupts&quot;</span>, <span class="kw-2">&amp;</span>[<span class="number">0</span>, <span class="self">self</span>.<span class="ident">irq</span>, <span class="number">1</span>]);
        <span class="self">self</span>.<span class="ident">ring_buffer</span>.<span class="ident">set_reg</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">node</span>, <span class="ident">spec</span>);
        <span class="ident">dt</span>.<span class="ident">root</span>.<span class="ident">set_child</span>(<span class="ident">name</span>, <span class="ident">node</span>);
    }
}

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Serialize</span>, <span class="ident">Deserialize</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">Device</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
    <span class="ident">Channel</span>(<span class="ident">Channel</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>),
    <span class="ident">Net</span>(<span class="ident">Net</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>),
    <span class="ident">Con</span>(<span class="ident">Con</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>),
}

<span class="kw">impl</span> <span class="ident">Device</span><span class="op">&lt;</span><span class="ident">RingBuffer</span><span class="op">&gt;</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">apply</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">dt</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">DeviceTree</span>) {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">Device::Channel</span>(<span class="ident">dev</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">dev</span>.<span class="ident">apply</span>(
                <span class="kw-2">&amp;</span><span class="macro">format!</span>(<span class="string">&quot;icecap_channel@{:x}&quot;</span>, <span class="ident">dev</span>.<span class="ident">ring_buffer</span>.<span class="ident">read</span>.<span class="ident">ctrl</span>.<span class="ident">start</span>),
                <span class="ident">dt</span>,
            ),
            <span class="ident">Device::Con</span>(<span class="ident">dev</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">dev</span>.<span class="ident">apply</span>(
                <span class="kw-2">&amp;</span><span class="macro">format!</span>(<span class="string">&quot;icecap_con@{:x}&quot;</span>, <span class="ident">dev</span>.<span class="ident">ring_buffer</span>.<span class="ident">read</span>.<span class="ident">ctrl</span>.<span class="ident">start</span>),
                <span class="ident">dt</span>,
            ),
            <span class="ident">Device::Net</span>(<span class="ident">dev</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">dev</span>.<span class="ident">apply</span>(
                <span class="kw-2">&amp;</span><span class="macro">format!</span>(<span class="string">&quot;icecap_net@{:x}&quot;</span>, <span class="ident">dev</span>.<span class="ident">ring_buffer</span>.<span class="ident">read</span>.<span class="ident">ctrl</span>.<span class="ident">start</span>),
                <span class="ident">dt</span>,
            ),
        }
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="ident">Device</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">traverse</span><span class="op">&lt;</span><span class="ident">T_</span>, <span class="ident">E</span><span class="op">&gt;</span>(<span class="self">self</span>, <span class="kw-2">mut</span> <span class="ident">f</span>: <span class="kw">impl</span> <span class="ident">FnMut</span>(<span class="ident">T</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">T_</span>, <span class="ident">E</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Device</span><span class="op">&lt;</span><span class="ident">T_</span><span class="op">&gt;</span>, <span class="ident">E</span><span class="op">&gt;</span> {
        <span class="prelude-val">Ok</span>(<span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">Device::Channel</span>(<span class="ident">Channel</span> {
                <span class="ident">ring_buffer</span>,
                <span class="ident">irq</span>,
                <span class="ident">name</span>,
                <span class="ident">id</span>,
            }) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">Device::Channel</span>(<span class="ident">Channel</span> {
                <span class="ident">ring_buffer</span>: <span class="ident">f</span>(<span class="ident">ring_buffer</span>)<span class="question-mark">?</span>,
                <span class="ident">irq</span>,
                <span class="ident">name</span>,
                <span class="ident">id</span>,
            }),
            <span class="ident">Device::Con</span>(<span class="ident">Con</span> { <span class="ident">ring_buffer</span>, <span class="ident">irq</span> }) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">Device::Con</span>(<span class="ident">Con</span> {
                <span class="ident">ring_buffer</span>: <span class="ident">f</span>(<span class="ident">ring_buffer</span>)<span class="question-mark">?</span>,
                <span class="ident">irq</span>,
            }),
            <span class="ident">Device::Net</span>(<span class="ident">Net</span> {
                <span class="ident">ring_buffer</span>,
                <span class="ident">mtu</span>,
                <span class="ident">mac_address</span>,
                <span class="ident">irq</span>,
            }) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">Device::Net</span>(<span class="ident">Net</span> {
                <span class="ident">ring_buffer</span>: <span class="ident">f</span>(<span class="ident">ring_buffer</span>)<span class="question-mark">?</span>,
                <span class="ident">mtu</span>,
                <span class="ident">mac_address</span>,
                <span class="ident">irq</span>,
            }),
        })
    }
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="icecap_fdt_bindings" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>